Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34921)
@@ -31,5 +31,5 @@
 #              16) Axel Kellner private communication (K10D)
 #              17) Cvetan Ivanov private communication (K100D)
-#              18) http://www.gvsoft.homedns.org/exif/makernote-pentax-type3.html
+#              18) http://gvsoft.homedns.org/exif/makernote-pentax-type3.html
 #              19) Dave Nicholson private communication (K10D)
 #              20) Bogdan and yeryry (http://www.cpanforum.com/posts/8037)
@@ -38,6 +38,13 @@
 #              23) Akos Szalkai (https://rt.cpan.org/Ticket/Display.html?id=43743)
 #              24) Albert Bogner private communication
-#              25) Niels Kristian Bech Jensen private communication
+#              26) https://exiftool.org/forum/index.php/topic,3444.0.html
+#              27) https://exiftool.org/forum/index.php/topic,3833.0.html
+#              28) Klaus Homeister https://exiftool.org/forum/index.php/topic,4803.0.html
+#              29) Louis Granboulan private communication (K-5II)
+#              30) https://exiftool.org/forum/index.php?topic=5433
+#              31) Andras Salamon private communication (K-70)
+#              IB) Iliah Borg private communication (LibRaw)
 #              JD) Jens Duttke private communication
+#              NJ) Niels Kristian Bech Jensen private communication
 #
 # Notes:        See POD documentation at the bottom of this file
@@ -47,31 +54,51 @@
 
 use strict;
-use vars qw($VERSION);
+use vars qw($VERSION %pentaxLensTypes);
 use Image::ExifTool::Exif;
+use Image::ExifTool::GPS;
 use Image::ExifTool::HP;
 
-$VERSION = '2.30';
+$VERSION = '3.36';
 
 sub CryptShutterCount($$);
 sub PrintFilter($$$);
+sub DecodeAFPoints($$$$;$);
 
 # pentax lens type codes (ref 4)
 # The first number gives the lens series, and the 2nd gives the model number
 # Series numbers: K=1; A=2; F=3; FAJ=4; DFA=4,7; FA=3,4,5,6; FA*=5,6;
-#                 DA=3,4,7; DA*=7,8; FA645=11; DFA645=13
-my %pentaxLensTypes = (
+#                 DA=3,4,7; DA*=7,8; FA645=11; DFA645=13; Q=21
+%pentaxLensTypes = (
     Notes => q{
         The first number gives the series of the lens, and the second identifies the
         lens model.  Note that newer series numbers may not always be properly
-        identified by cameras running older firmware versions.  Decimal values
-        differentiate lenses which would otherwise have the same LensType, and are
-        used by the Composite LensID tag when attempting to identify the specific
-        lens model.
+        identified by cameras running older firmware versions.  Decimal values have
+        been added to differentiate lenses which would otherwise have the same
+        LensType, and are used by the Composite LensID tag when attempting to
+        identify the specific lens model.
+    },
+    OTHER => sub {
+        my ($val, $inv, $conv) = @_;
+        return undef if $inv;
+        # *istD may report a series number of 4 for series 7 lenses
+        $val =~ s/^4 /7 / and $$conv{$val} and return "$$conv{$val} ($_[0])";
+        # cameras that don't recognize SDM lenses (eg. older K10 firmware)
+        # may report series 7 instead of 8
+        $val =~ s/^7 /8 / and $$conv{$val} and return "$$conv{$val} ? ($_[0])";
+        # there seems to some inconsistency between FA and DFA lenses for the 645D...
+        ($val =~ s/^11 /13 / or $val =~ s/^13 /11 /) and $$conv{$val} and return "$$conv{$val} ? ($_[0])";
+        return undef;
     },
     '0 0' => 'M-42 or No Lens', #17
     '1 0' => 'K or M Lens',
     '2 0' => 'A Series Lens', #7 (from smc PENTAX-A 400mm F5.6)
-    '3 0' => 'Sigma', # (includes 'Sigma 30mm F1.4 EX DC' - PH)
-    '3 17' => 'smc PENTAX-FA SOFT 85mm F2.8',
+    '3 0' => 'Sigma',
+    # (and 'Sigma 18-50mm F2.8 EX Macro')
+    # (and 'Sigma 30mm F1.4 EX DC', ref PH)
+    # (and 'Sigma 50-500mm F4-6.3 DG APO')
+    # (and 'Sigma 70mm F2.8 EX DG Macro')
+    # (and 'Sigma 105mm F2.8 EX DG Macro', ref 24)
+    # (and 'Sigma 180mm F4.5 EX DG Macro')
+    '3 17' => 'smc PENTAX-FA SOFT 85mm F2.8', # (also F version, ref 29)
     '3 18' => 'smc PENTAX-F 1.7X AF ADAPTER',
     '3 19' => 'smc PENTAX-F 24-50mm F4',
@@ -82,9 +109,10 @@
     '3 23.1' => 'Sigma AF 28-300mm F3.5-5.6 DL IF', #JD
     '3 23.2' => 'Sigma AF 28-300mm F3.5-6.3 DG IF Macro', #JD
+    '3 23.3' => 'Tokina 80-200mm F2.8 ATX-Pro', #Exiv2
     '3 24' => 'smc PENTAX-F 35-135mm F3.5-4.5',
     '3 25' => 'smc PENTAX-F 35-105mm F4-5.6 or Sigma or Tokina Lens',
-    '3 25.1' => 'Sigma AF 28-300mm F3.5-5.6 DL IF', #11
-    '3 25.2' => 'Sigma 55-200mm F4-5.6 DC', #JD
-    '3 25.3' => 'Sigma AF 28-300mm F3.5-5.6 DL IF', #JD
+    '3 25.1' => 'Sigma 55-200mm F4-5.6 DC', #JD
+    '3 25.2' => 'Sigma AF 28-300mm F3.5-5.6 DL IF', #11
+    '3 25.3' => 'Sigma AF 28-300mm F3.5-6.3 DL IF', #Exiv2
     '3 25.4' => 'Sigma AF 28-300mm F3.5-6.3 DG IF Macro', #JD
     '3 25.5' => 'Tokina 80-200mm F2.8 ATX-Pro', #12
@@ -94,4 +122,5 @@
     '3 28' => 'smc PENTAX-F 35-70mm F3.5-4.5 or Tokina Lens',
     '3 28.1' => 'Tokina 19-35mm F3.5-4.5 AF', #12
+    '3 28.2' => 'Tokina AT-X AF 400mm F5.6', #NJ
     '3 29' => 'PENTAX-F 28-80mm F3.5-4.5 or Sigma or Tokina Lens',
     '3 29.1' => 'Sigma AF 18-125mm F3.5-5.6 DC', #11
@@ -111,13 +140,17 @@
     '3 41' => 'smc PENTAX-F Macro 50mm F2.8 or Sigma Lens', #4
     '3 41.1' => 'Sigma 50mm F2.8 Macro', #16
+    '3 42' => 'Sigma 300mm F2.8 EX DG APO IF', #27
     '3 44' => 'Sigma or Tamron Lens (3 44)',
     '3 44.1' => 'Sigma AF 10-20mm F4-5.6 EX DC', #JD
-    '3 44.2' => 'Sigma 12-24mm F4.5 EX DG', #12
+    '3 44.2' => 'Sigma 12-24mm F4.5-5.6 EX DG', #12 (added "-5.6", ref 29)
     '3 44.3' => 'Sigma 17-70mm F2.8-4.5 DC Macro', #(Bart Hickman)
     '3 44.4' => 'Sigma 18-50mm F3.5-5.6 DC', #4
-    '3 44.5' => 'Tamron 35-90mm F4 AF', #12
-    '3 46' => 'Sigma Lens (3 46)',
+    '3 44.5' => 'Sigma 17-35mm F2.8-4 EX DG', #29
+    '3 44.6' => 'Tamron 35-90mm F4-5.6 AF', #12 (added "-5.6", ref IB)
+    '3 44.7' => 'Sigma AF 18-35mm F3.5-4.5 Aspherical', #29
+    '3 46' => 'Sigma or Samsung Lens (3 46)',
     '3 46.1' => 'Sigma APO 70-200mm F2.8 EX',
     '3 46.2' => 'Sigma EX APO 100-300mm F4 IF', #JD
+    '3 46.3' => 'Samsung/Schneider D-XENON 50-200mm F4-5.6 ED', #29
     '3 50' => 'smc PENTAX-FA 28-70mm F4 AL',
     '3 51' => 'Sigma 28mm F1.8 EX DG Aspherical Macro',
@@ -141,9 +174,12 @@
     '3 255.7' => 'Sigma 70-300mm F4-5.6 Macro', #JD
     '3 255.8' => 'Sigma 55-200mm F4-5.6 DC', #JD
-    '3 255.9' => 'Sigma 18-50mm F2.8 EX DC', #JD
+    '3 255.9' => 'Sigma 18-50mm F2.8 EX DC', #JD (also Macro version - PH)
     '4 1' => 'smc PENTAX-FA SOFT 28mm F2.8',
     '4 2' => 'smc PENTAX-FA 80-320mm F4.5-5.6',
     '4 3' => 'smc PENTAX-FA 43mm F1.9 Limited',
     '4 6' => 'smc PENTAX-FA 35-80mm F4-5.6',
+    '4 8' => 'Irix 150mm F2.8 Macro', #exiv2 issue 1084
+    '4 9' => 'Irix 11mm F4 Firefly', #27
+    '4 10' => 'Irix 15mm F2.4', #27
     '4 12' => 'smc PENTAX-FA 50mm F1.4', #17
     '4 15' => 'smc PENTAX-FA 28-105mm F4-5.6 [IF]',
@@ -163,5 +199,6 @@
     '4 34' => 'smc PENTAX-FA 24-90mm F3.5-4.5 AL[IF]',
     '4 35' => 'smc PENTAX-FA 100-300mm F4.7-5.8',
-    '4 36' => 'Tamron AF70-300mm F4-5.6 LD Macro', # both 572D and A17 (Di) - ref JD
+  # '4 36' => 'Tamron AF70-300mm F4-5.6 LD Macro', # both 572D and A17 (Di) - ref JD
+    '4 36' => 'Tamron AF 70-300mm F4-5.6 LD Macro 1:2', #NJ
     '4 37' => 'Tamron SP AF 24-135mm F3.5-5.6 AD AL (190D)', #13
     '4 38' => 'smc PENTAX-FA 28-105mm F3.2-4.5 AL[IF]',
@@ -175,17 +212,22 @@
     '4 46' => 'smc PENTAX-FA J 28-80mm F3.5-5.6 AL',
     '4 47' => 'smc PENTAX-FA J 18-35mm F4-5.6 AL',
-    '4 49' => 'Tamron SP AF 28-75mm F2.8 XR Di (A09)',
+   #'4 49' => 'Tamron SP AF 28-75mm F2.8 XR Di (A09)',
+    '4 49' => 'Tamron SP AF 28-75mm F2.8 XR Di LD Aspherical [IF] Macro', #NJ
     '4 51' => 'smc PENTAX-D FA 50mm F2.8 Macro',
     '4 52' => 'smc PENTAX-D FA 100mm F2.8 Macro',
+    '4 55' => 'Samsung/Schneider D-XENOGON 35mm F2', #29
+    '4 56' => 'Samsung/Schneider D-XENON 100mm F2.8 Macro', #Alan Robinson
     '4 75' => 'Tamron SP AF 70-200mm F2.8 Di LD [IF] Macro (A001)', #JD
+    '4 214' => 'smc PENTAX-DA 35mm F2.4 AL', #PH
     '4 229' => 'smc PENTAX-DA 18-55mm F3.5-5.6 AL II', #JD
     '4 230' => 'Tamron SP AF 17-50mm F2.8 XR Di II', #20
     '4 231' => 'smc PENTAX-DA 18-250mm F3.5-6.3 ED AL [IF]', #21
     '4 237' => 'Samsung/Schneider D-XENOGON 10-17mm F3.5-4.5', #JD
-    '4 239' => 'Samsung D-XENON 12-24mm F4 ED AL [IF]', #23
+    '4 239' => 'Samsung/Schneider D-XENON 12-24mm F4 ED AL [IF]', #23
+    '4 242' => 'smc PENTAX-DA* 16-50mm F2.8 ED AL [IF] SDM (SDM unused)', #Pietu Pohjalainen
     '4 243' => 'smc PENTAX-DA 70mm F2.4 Limited', #JD
     '4 244' => 'smc PENTAX-DA 21mm F3.2 AL Limited', #9
-    '4 245' => 'Schneider D-XENON 50-200mm F4-5.6', #15
-    '4 246' => 'Schneider D-XENON 18-55mm F3.5-5.6', #15
+    '4 245' => 'Samsung/Schneider D-XENON 50-200mm F4-5.6', #15
+    '4 246' => 'Samsung/Schneider D-XENON 18-55mm F3.5-5.6', #15
     '4 247' => 'smc PENTAX-DA FISH-EYE 10-17mm F3.5-4.5 ED[IF]', #10
     '4 248' => 'smc PENTAX-DA 12-24mm F4 ED AL [IF]', #10
@@ -228,4 +270,14 @@
     '7 58' => 'smc PENTAX-D FA Macro 100mm F2.8 WR', #PH - this bit of information cost me $600 ;)
     '7 75' => 'Tamron SP AF 70-200mm F2.8 Di LD [IF] Macro (A001)', #(Anton Bondar)
+    '7 201' => 'smc Pentax-DA L 50-200mm F4-5.6 ED WR', #(Bruce Rusk)
+    '7 202' => 'smc PENTAX-DA L 18-55mm F3.5-5.6 AL WR', #29
+    '7 203' => 'HD PENTAX-DA 55-300mm F4-5.8 ED WR', #29
+    '7 204' => 'HD PENTAX-DA 15mm F4 ED AL Limited', #forum5318
+    '7 205' => 'HD PENTAX-DA 35mm F2.8 Macro Limited', #29
+    '7 206' => 'HD PENTAX-DA 70mm F2.4 Limited', #29
+    '7 207' => 'HD PENTAX-DA 21mm F3.2 ED AL Limited', #forum5327
+    '7 208' => 'HD PENTAX-DA 40mm F2.8 Limited', #PH
+    '7 212' => 'smc PENTAX-DA 50mm F1.8', #PH
+    '7 213' => 'smc PENTAX-DA 40mm F2.8 XS', #PH
     '7 214' => 'smc PENTAX-DA 35mm F2.4 AL', #PH
     '7 216' => 'smc PENTAX-DA L 55-300mm F4-5.8 ED', #PH
@@ -235,9 +287,10 @@
     '7 221' => 'smc PENTAX-DA L 50-200mm F4-5.6 ED', #Ar't
     '7 222' => 'smc PENTAX-DA L 18-55mm F3.5-5.6', #PH (tag 0x003f -- was '7 229' in LensInfo of one test image)
-    '7 223' => 'Samsung D-XENON 18-55mm F3.5-5.6 II', #PH
+    '7 223' => 'Samsung/Schneider D-XENON 18-55mm F3.5-5.6 II', #PH
     '7 224' => 'smc PENTAX-DA 15mm F4 ED AL Limited', #JD
-    '7 225' => 'Samsung D-XENON 18-250mm F3.5-6.3', #8/PH
+    '7 225' => 'Samsung/Schneider D-XENON 18-250mm F3.5-6.3', #8/PH
     '7 226' => 'smc PENTAX-DA* 55mm F1.4 SDM (SDM unused)', #PH (NC)
-    '7 227' => 'smc PENTAX DA* 60-250mm F4 [IF] SDM (SDM unused)', #PH (NC)
+    '7 227' => 'smc PENTAX-DA* 60-250mm F4 [IF] SDM (SDM unused)', #PH (NC)
+    '7 228' => 'Samsung 16-45mm F4 ED', #29
     '7 229' => 'smc PENTAX-DA 18-55mm F3.5-5.6 AL II', #JD
     '7 230' => 'Tamron AF 17-50mm F2.8 XR Di-II LD (Model A16)', #JD
@@ -252,9 +305,51 @@
     '7 243' => 'smc PENTAX-DA 70mm F2.4 Limited', #PH
     '7 244' => 'smc PENTAX-DA 21mm F3.2 AL Limited', #16
+    '8 0' => 'Sigma 50-150mm F2.8 II APO EX DC HSM', #forum2997
+    '8 3' => 'Sigma 18-125mm F3.8-5.6 DC HSM', #forum10167
+    '8 4' => 'Sigma 50mm F1.4 EX DG HSM', #Artur private communication
+    '8 6' => 'Sigma 4.5mm F2.8 EX DC Fisheye', #IB
+    '8 7' => 'Sigma 24-70mm F2.8 IF EX DG HSM', #Exiv2
+    '8 8' => 'Sigma 18-250mm F3.5-6.3 DC OS HSM', #27
+    '8 11' => 'Sigma 10-20mm F3.5 EX DC HSM', #27
+    '8 12' => 'Sigma 70-300mm F4-5.6 DG OS', #forum3382
+    '8 13' => 'Sigma 120-400mm F4.5-5.6 APO DG OS HSM', #26
     '8 14' => 'Sigma 17-70mm F2.8-4.0 DC Macro OS HSM', #(Hubert Meier)
-    '8 18' => 'Sigma 8-16mm F4.5-5.6 DC HSM', #http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2998.0.html
+    '8 15' => 'Sigma 150-500mm F5-6.3 APO DG OS HSM', #26
+    '8 16' => 'Sigma 70-200mm F2.8 EX DG Macro HSM II', #26
+    '8 17' => 'Sigma 50-500mm F4.5-6.3 DG OS HSM', #(Heike Herrmann) (also APO, ref 26)
+    '8 18' => 'Sigma 8-16mm F4.5-5.6 DC HSM', #forum2998
+    '8 20' => 'Sigma 18-50mm F2.8-4.5 DC HSM', #IB
+    '8 21' => 'Sigma 17-50mm F2.8 EX DC OS HSM', #26
+    '8 22' => 'Sigma 85mm F1.4 EX DG HSM', #26
+    '8 23' => 'Sigma 70-200mm F2.8 APO EX DG OS HSM', #27
+    '8 24' => 'Sigma 17-70mm F2.8-4 DC Macro OS HSM', #27
+    '8 25' => 'Sigma 17-50mm F2.8 EX DC HSM', #Exiv2
+    '8 27' => 'Sigma 18-200mm F3.5-6.3 II DC HSM', #27
+    '8 28' => 'Sigma 18-250mm F3.5-6.3 DC Macro HSM', #27
+    '8 29' => 'Sigma 35mm F1.4 DG HSM', #27
+    '8 30' => 'Sigma 17-70mm F2.8-4 DC Macro HSM | C', #27
+    '8 31' => 'Sigma 18-35mm F1.8 DC HSM', #27
+    '8 32' => 'Sigma 30mm F1.4 DC HSM | A', #27
+    '8 33' => 'Sigma 18-200mm F3.5-6.3 DC Macro HSM', #DieterPearcey (C014)
+    '8 34' => 'Sigma 18-300mm F3.5-6.3 DC Macro HSM', #NJ
+    '8 59' => 'HD PENTAX-D FA 150-450mm F4.5-5.6 ED DC AW', #29
+    '8 60' => 'HD PENTAX-D FA* 70-200mm F2.8 ED DC AW', #29
+    '8 61' => 'HD PENTAX-D FA 28-105mm F3.5-5.6 ED DC WR', #PH
+    '8 62' => 'HD PENTAX-D FA 24-70mm F2.8 ED SDM WR', #PH
+    '8 63' => 'HD PENTAX-D FA 15-30mm F2.8 ED SDM WR', #PH
+    '8 64' => 'HD PENTAX-D FA* 50mm F1.4 SDM AW', #27
+    '8 65' => 'HD PENTAX-D FA 70-210mm F4 ED SDM WR', #PH
+    '8 66' => 'HD PENTAX-D FA 85mm F1.4 ED SDM AW', #James O'Neill
+    '8 196' => 'HD PENTAX-DA* 11-18mm F2.8 ED DC AW', #29
+    '8 197' => 'HD PENTAX-DA 55-300mm F4.5-6.3 ED PLM WR RE', #29
+    '8 198' => 'smc PENTAX-DA L 18-50mm F4-5.6 DC WR RE', #29
+    '8 199' => 'HD PENTAX-DA 18-50mm F4-5.6 DC WR RE', #29
+    '8 200' => 'HD PENTAX-DA 16-85mm F3.5-5.6 ED DC WR', #29
+    '8 209' => 'HD PENTAX-DA 20-40mm F2.8-4 ED Limited DC WR', #29
+    '8 210' => 'smc PENTAX-DA 18-270mm F3.5-6.3 ED SDM', #Helmut Schutz
+    '8 211' => 'HD PENTAX-DA 560mm F5.6 ED AW', #PH
     '8 215' => 'smc PENTAX-DA 18-135mm F3.5-5.6 ED AL [IF] DC WR', #PH
     '8 226' => 'smc PENTAX-DA* 55mm F1.4 SDM', #JD
-    '8 227' => 'smc PENTAX DA* 60-250mm F4 [IF] SDM', #JD
+    '8 227' => 'smc PENTAX-DA* 60-250mm F4 [IF] SDM', #JD
     '8 232' => 'smc PENTAX-DA 17-70mm F4 AL [IF] SDM', #JD
     '8 234' => 'smc PENTAX-DA* 300mm F4 ED [IF] SDM', #19
@@ -264,11 +359,51 @@
     '8 255' => 'Sigma Lens (8 255)',
     '8 255.1' => 'Sigma 70-200mm F2.8 EX DG Macro HSM II', #JD
-    '8 255.2' => 'Sigma APO 150-500mm F5-6.3 DG OS HSM', #JD
-    '8 255.3' => 'Sigma 50-150mm F2.8 II APO EX DC HSM', #http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2997.0.html
+    '8 255.2' => 'Sigma 150-500mm F5-6.3 DG APO [OS] HSM', #JD (non-OS version has same type, ref 29)
+    '8 255.3' => 'Sigma 50-150mm F2.8 II APO EX DC HSM', #forum2997
+    '8 255.4' => 'Sigma 4.5mm F2.8 EX DC HSM Circular Fisheye', #PH
+    '8 255.5' => 'Sigma 50-200mm F4-5.6 DC OS', #26
+    '8 255.6' => 'Sigma 24-70mm F2.8 EX DG HSM', #29
+#
+# 645 lenses
+#
+    '9 0' => '645 Manual Lens', #PH (NC)
+    '10 0' => '645 A Series Lens', #PH
+    '11 1' => 'smc PENTAX-FA 645 75mm F2.8', #PH
+    '11 2' => 'smc PENTAX-FA 645 45mm F2.8', #PH
+    '11 3' => 'smc PENTAX-FA* 645 300mm F4 ED [IF]', #PH
     '11 4' => 'smc PENTAX-FA 645 45-85mm F4.5', #PH
+    '11 5' => 'smc PENTAX-FA 645 400mm F5.6 ED [IF]', #PH
+    '11 7' => 'smc PENTAX-FA 645 Macro 120mm F4', #PH
     '11 8' => 'smc PENTAX-FA 645 80-160mm F4.5', #PH
+    '11 9' => 'smc PENTAX-FA 645 200mm F4 [IF]', #PH
+    '11 10' => 'smc PENTAX-FA 645 150mm F2.8 [IF]', #PH
     '11 11' => 'smc PENTAX-FA 645 35mm F3.5 AL [IF]', #PH
+    '11 12' => 'smc PENTAX-FA 645 300mm F5.6 ED [IF]', #29
+    '11 14' => 'smc PENTAX-FA 645 55-110mm F5.6', #PH
+    '11 16' => 'smc PENTAX-FA 645 33-55mm F4.5 AL', #PH
     '11 17' => 'smc PENTAX-FA 645 150-300mm F5.6 ED [IF]', #PH
+    '11 21' => 'HD PENTAX-D FA 645 35mm F3.5 AL [IF]', #29
     '13 18' => 'smc PENTAX-D FA 645 55mm F2.8 AL [IF] SDM AW', #PH
+    '13 19' => 'smc PENTAX-D FA 645 25mm F4 AL [IF] SDM AW', #PH
+    '13 20' => 'HD PENTAX-D FA 645 90mm F2.8 ED AW SR', #PH
+    '13 253' => 'HD PENTAX-DA 645 28-45mm F4.5 ED AW SR', #Dominique Schrekling email
+    '13 254' => 'smc PENTAX-DA 645 25mm F4 AL [IF] SDM AW', #forum8253
+#
+# Q-mount lenses (21=auto focus lens, 22=manual focus)
+#
+    '21 0' => 'Pentax Q Manual Lens', #PH
+    '21 1' => '01 Standard Prime 8.5mm F1.9', #PH
+    '21 2' => '02 Standard Zoom 5-15mm F2.8-4.5', #PH
+    '22 3' => '03 Fish-eye 3.2mm F5.6', #PH
+    '22 4' => '04 Toy Lens Wide 6.3mm F7.1', #PH
+    '22 5' => '05 Toy Lens Telephoto 18mm F8', #PH
+    '21 6' => '06 Telephoto Zoom 15-45mm F2.8', #PH
+    '21 7' => '07 Mount Shield 11.5mm F9', #PH (NC)
+    '21 8' => '08 Wide Zoom 3.8-5.9mm F3.7-4', #PH (NC)
+    '21 233' => 'Adapter Q for K-mount Lens', #29
+#
+# Ricoh lenses
+#
+    '31 1' => 'GR Lens', #PH (GR III 28mm F2.8)
 );
 
@@ -327,8 +462,8 @@
     0x12c3c => 'Optio W20',
     0x12c46 => 'Optio A20',
-    0x12c8c => 'Optio M30',
     0x12c78 => 'Optio E30',
     0x12c7d => 'Optio E35',
     0x12c82 => 'Optio T30',
+    0x12c8c => 'Optio M30',
     0x12c91 => 'Optio L30',
     0x12c96 => 'Optio W30',
@@ -373,7 +508,46 @@
     0x12e6c => 'K-r',
     0x12e76 => 'K-5',
-    0x12e8a => 'Optio RS1000 / RS1500',
+    0x12e8a => 'Optio RS1000/RS1500',
     0x12e94 => 'Optio RZ10',
+    0x12e9e => 'Optio LS1000',
     0x12ebc => 'Optio WG-1 GPS',
+    0x12ed0 => 'Optio S1',
+    0x12ee4 => 'Q',
+    0x12ef8 => 'K-01',
+    0x12f0c => 'Optio RZ18',
+    0x12f16 => 'Optio VS20',
+    0x12f2a => 'Optio WG-2 GPS',
+    0x12f48 => 'Optio LS465',
+    0x12f52 => 'K-30',
+    0x12f5c => 'X-5',
+    0x12f66 => 'Q10',
+    0x12f70 => 'K-5 II',
+    0x12f71 => 'K-5 II s', #forum4515
+    0x12f7a => 'Q7',
+    0x12f84 => 'MX-1',
+    0x12f8e => 'WG-3 GPS',
+    0x12f98 => 'WG-3',
+    0x12fa2 => 'WG-10',
+    0x12fb6 => 'K-50',
+    0x12fc0 => 'K-3', #29
+    0x12fca => 'K-500',
+    0x12fe8 => 'WG-4', # (Ricoh)
+    0x12fde => 'WG-4 GPS', # (Ricoh)
+    0x13006 => 'WG-20', # (Ricoh)
+    0x13010 => '645Z',
+    0x1301a => 'K-S1',
+    0x13024 => 'K-S2', #29 (Ricoh)
+    0x1302e => 'Q-S1',
+    0x13056 => 'WG-30', # (Ricoh)
+    0x1307e => 'WG-30W', # (Ricoh)
+    0x13088 => 'WG-5 GPS', # (Ricoh)
+    0x13092 => 'K-1', #IB (Ricoh)
+    0x1309c => 'K-3 II', #29 (Ricoh)
+    0x131f0 => 'WG-M2', # (Ricoh)
+    0x1320e => 'GR III', # (Ricoh)
+    0x13222 => 'K-70', #29 (Ricoh)
+    0x1322c => 'KP', #29 (Ricoh)
+    0x13240 => 'K-1 Mark II', # (Ricoh)
+    0x13290 => 'WG-70', # (Ricoh)
 );
 
@@ -384,5 +558,5 @@
     2 => 'Anchorage',
     3 => 'Vancouver',
-    4 => 'San Fransisco',
+    4 => 'San Francisco',
     5 => 'Los Angeles',
     6 => 'Calgary',
@@ -451,5 +625,5 @@
     69 => 'Stockholm',
     70 => 'Lisbon', #14
-    71 => 'Copenhagen', #25
+    71 => 'Copenhagen', #NJ
     72 => 'Warsaw',
     73 => 'Prague',
@@ -489,4 +663,10 @@
         18 => 'Posterization',
         19 => 'Sketch Filter',
+        20 => 'Shading', # (Q)
+        21 => 'Invert Color', # (Q)
+        23 => 'Tone Expansion', #Forum5247
+        27 => 'Unicolor Bold', #31
+        28 => 'Bold Monochrome', #31
+        29 => 'Replace Color', #31
         254 => 'Custom Filter',
     },
@@ -506,9 +686,9 @@
     9  => ['Color',         { 1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], # Color Filter
     10 => ['Density',       { 1=>'Light',2=>'Standard',3=>'Dark' }], # Color Filter
-    11 => ['ExtractedColor',{ 0=>'Off',1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], # ExtractColor [x2]
-    12 => ['ColorRange', '%+d'],    # ExtractColor [x2] (-2-+2)
+    11 => ['ExtractedColor',{ 0=>'Off',1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], # Extract Color [x2]
+    12 => ['ColorRange', '%+d'],    # Extract Color [x2] (-2-+2)
     13 => ['FilterEffect',  { 0=>'Off',1=>'Red',2=>'Green',3=>'Blue',4=>'Infrared'}], # Monochrome
     14 => ['ToningBA', '%+d'],      # Monochrome (-3-+3)
-    15 => ['InvertColor',   { 0=>'Off',1=>'On' }], # Custom
+    15 => ['InvertColor',   { 0=>'Off',1=>'On' }], # Custom/Invert Color
     16 => ['Slim', '%+d'],          # Slim (-8-+8)
     17 => ['EffectDensity', { 1=>'Sparse',2=>'Normal',3=>'Dense' }], # Starburst
@@ -518,6 +698,6 @@
     21 => ['DistortionType', '%d'], # Custom (1-3)
     22 => ['DistortionLevel',{0=>'Off',1=>'Weak',2=>'Medium',3=>'Strong' }], #Custom
-    23 => ['ShadingType', '%d'],    # Custom (1-6)
-    24 => ['ShadingLevel', '%+d'],  # Custom (-3-+3)
+    23 => ['ShadingType', '%d'],    # Custom/Shading (1-6)
+    24 => ['ShadingLevel', '%+d'],  # Custom/Shading (-3-+3)
     25 => ['Shading', '%d'],        # Toy Camera (1-3)
     26 => ['Blur',  '%d'],          # Toy Camera (1-3)
@@ -529,4 +709,5 @@
     32 => ['Saturation2',   { 0=>'Off',1=>'Low',2=>'Medium',3=>'High' }], # Water Color
     33 => ['HDR',           { 1=>'Weak',2=>'Medium',3=>'Strong' }], # HDR
+    # (34 missing)
     35 => ['FocusPlane', '%+d'],    # Miniature (-3-+3)
     36 => ['FocusWidth',    { 1=>'Narrow',2=>'Middle',3=>'Wide' }], # Miniature
@@ -537,4 +718,11 @@
     41 => ['Contrast2',     { 1=>'Low',2=>'Medium',3=>'High'}], # Sketch Filter
     42 => ['ScratchEffect', { 0=>'Off',1=>'On' }], # Sketch Filter
+    45 => ['ToneExpansion', { 1=>'Low',2=>'Medium',3=>'High' }], # Tone Expansion (ref Forum5247)
+    47 => ['UnicolorBold',  { 1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], #31 Unicolor Bold
+    48 => ['BoldMonochrome', '%d'], #31 Bold Monochrome (1-3)
+    49 => ['OriginalColor', { 1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], #31 Replace Color
+    50 => ['NewColor',      { 1=>'Red',2=>'Magenta',3=>'Blue',4=>'Cyan',5=>'Green',6=>'Yellow' }], #31 Replace Color
+    51 => ['ColorScale', '%d'], #31 Replace Color (1-5)
+    52 => ['Toning2', '%+d'], #31 Extract Color (-3-+3)
 );
 
@@ -578,4 +766,47 @@
     PrintConvInv => 'hex($val)',
 );
+
+# conversions for tags 0x0053-0x005a
+my %colorTemp = (
+    Writable => 'undef',
+    Count => 4,
+    ValueConv => sub {
+        my $val = shift;
+        return $val unless length $val == 4;
+        my @a = unpack 'nCC', $val;
+        $a[0] = 53190 - $a[0];
+        $a[1] = ($a[2] & 0x0f); $a[1] -= 16 if $a[1] >= 8;
+        $a[2] = ($a[2] >> 4);   $a[2] -= 16 if $a[2] >= 8;
+        return "@a";
+    },
+    ValueConvInv => sub {
+        my $val = shift;
+        my @a = split ' ', $val;
+        return undef unless @a == 3;
+        return pack 'nCC', 53190 - $a[0], 0, ($a[1] & 0x0f) + (($a[2] & 0x0f) << 4);
+    },
+    PrintConv => sub {
+        $_ = shift;
+        s/ ([1-9])/ +$1/g;
+        s/ 0/  0/g;
+        return $_;
+    },
+    PrintConvInv => '$val',
+);
+
+# conversions for KelvinWB tags
+my %kelvinWB = (
+    Format => 'int16u[4]',
+    ValueConv => sub {
+        my @a = split ' ', shift;
+        (53190 - $a[0]) . ' ' . $a[1] . ' ' . ($a[2] / 8192) . ' ' . ($a[3] / 8192);
+    },
+    ValueConvInv => sub {
+        my @a = split ' ', shift;
+        (53190 - $a[0]) . ' ' . $a[1] . ' ' . int($a[2]*8192+0.5) . ' ' . int($a[3]*8192+0.5);
+    },
+);
+
+my %noYes = ( 0 => 'No', 1 => 'Yes' );
 
 # common attributes for writable BinaryData directories
@@ -600,4 +831,52 @@
         PrintConv => '$val=~tr/ /./; $val',
         PrintConvInv => '$val=~tr/./ /; $val',
+        # 0.1.0.3 - PENTAX Optio E40
+        # 3.0.0.0 - K10D
+        # 3.1.0.0 - Optio A40/S10/L36/L40/M40/V10
+        # 3.1.1.0 - Optio L36/L40/M40/V10
+        # 3.1.2.0 - Optio Z10
+        # 4.0.2.0 - Optio E50
+        # 4.1.0.0 - Optio S12
+        # 4.1.1.0 - Optio M50
+        # 4.1.2.0 - K20D, K200D
+        # 4.2.0.0 - Optio L50/V20
+        # 4.2.1.0 - Optio E60/M90
+        # 4.2.2.0 - Optio W60
+        # 4.2.3.0 - Optio M60
+        # 4.4.0.1 - K-m, K2000
+        # 4.5.0.0 - Optio E70/L70
+        # 4.5.0.0 - Optio E70/L70/P70
+        # 4.6.0.0 - Optio E80/E90/W80
+        # 5.0.0.0 - K-7, Optio P80/WS80
+        # 5.1.0.0 - K-x
+        # 5.2.0.0 - Optio I-10
+        # 5.3.0.0 - Optio H90
+        # 5.3.2.0 - Optio W90/X90
+        # 6.0.0.0 - K-r, 645D
+        # 6.1.3.0 - Optio LS1000/RS1000/RS1500/RZ10
+        # 7.0.0.0 - K-5
+        # 7.1.0.0 - Optio WG-1GPS/WG-10/WG-20
+        # 7.2.0.0 - Optio S1
+        # 8.0.0.0 - Q
+        # 8.0.1.0 - Optio RZ18
+        # 8.0.4.0 - Optio VS20
+        # 8.1.0.0 - Optio LS465/WG-2GPS
+        # 9.0.0.0 - K-01
+        # 9.1.2.0 - X-5
+        # 10.0.0.0 - K-30, K-50, K-500, K-5 II, K-5 II s
+        # 10.0.2.0 - Q10
+        # 10.2.0.0 - WG-3/WG-4
+        # 10.2.1.0 - MX-1
+        # 10.4.1.0 - WG-3/4/5 GPS, WG-30/30W
+        # 10.6.1.0 - Q-S1, Q7
+        # 11.0.0.0 - K-3
+        # 11.2.1.0 - 645Z
+        # 11.3.0.0 - K-S1
+        # 11.5.0.0 - K-S2
+        # 11.6.1.0 - K-3 II
+        # 11.7.5.0 - WG-M2
+        # 12.0.0.0 - K-1
+        # 12.1.3.0 - K-70
+        # 12.1.5.0 - KP
     },
     0x0001 => { #PH
@@ -612,4 +891,5 @@
         Count => 2,
         PrintConv => '$val =~ tr/ /x/; $val',
+        PrintConvInv => '$val =~ tr/x/ /; $val',
     },
     0x0003 => { #PH
@@ -619,4 +899,5 @@
         Groups => { 2 => 'Image' },
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -624,9 +905,10 @@
         Name => 'PreviewImageStart',
         IsOffset => 2,  # code to use original base
-        Protected => 2,
         OffsetPair => 0x0003, # point to associated byte count
         DataTag => 'PreviewImage',
         Groups => { 2 => 'Image' },
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
+        Protected => 2,
     },
     0x0005 => { #13
@@ -635,4 +917,6 @@
         PrintHex => 1,
         SeparateTable => 1,
+        DataMember => 'PentaxModelID',
+        RawConv => '$$self{PentaxModelID} = $val',
         PrintConv => \%pentaxModelID,
     },
@@ -679,4 +963,7 @@
             4 => 'RAW', #5
             5 => 'Premium', #PH (K20D)
+            7 => 'RAW (pixel shift enabled)', #forum6536 (K-3 II)
+            8 => 'Dynamic Pixel Shift', #IB
+            65535 => 'n/a', #PH (Q MOV video)
         },
     },
@@ -705,5 +992,7 @@
             29 => '4000x3000', #PH (X70)
             30 => '4288x3216', #PH (Optio RS1000)
+            31 => '4608x3456', #PH (Optio RZ18)
             129 => '1920x1080', #PH (Optio RZ10)
+            135 => '4608x2592', #PH (Q10 stretch filter)
             257 => '3216x3216', #PH (Optio RZ10)
             '0 0' => '2304x1728', #13
@@ -717,4 +1006,5 @@
             '36 0' => '3008x2008 or 3040x2024',  #PH
             '37 0' => '3008x2000', #13
+            # 65535 - seen for an X-5 panorama (PH)
         },
     },
@@ -727,5 +1017,5 @@
             different from other models
         },
-        ValueConv => '($val < 4 and $$self{Model} =~ /Optio 555\b/) ? $val + 0.1 : $val',
+        ValueConv => '(IsInt($val) and $val < 4 and $$self{Model} =~ /Optio 555\b/) ? $val + 0.1 : $val',
         ValueConvInv => 'int $val',
         PrintConvColumns => 2,
@@ -764,8 +1054,8 @@
             31 => 'Illustrations', #13
             33 => 'Digital Filter', #13
-            35 => 'Night Scene Portrait', #25
+            35 => 'Night Scene Portrait', #NJ
             37 => 'Museum', #PH
             38 => 'Food', #PH
-            39 => 'Underwater', #25
+            39 => 'Underwater', #NJ
             40 => 'Green Mode', #PH
             49 => 'Light Pet', #PH
@@ -777,8 +1067,16 @@
             56 => 'Synchro Sound Record', #PH
             58 => 'Frame Composite', #14
-            59 => 'Report', #25
+            59 => 'Report', #NJ
             60 => 'Kids', #13
             61 => 'Blur Reduction', #13
+            63 => 'Panorama 2', #PH (X-5)
             65 => 'Half-length Portrait', #JD
+            66 => 'Portrait 2', #PH (LS645)
+            74 => 'Digital Microscope', #PH (WG-4)
+            75 => 'Blue Sky', #PH (LS465)
+            80 => 'Miniature', #PH (VS20)
+            81 => 'HDR', #PH (LS465)
+            83 => 'Fisheye', #PH (VS20)
+            85 => 'Digital Filter 4', #PH (WG-5)
             221 => 'P', #PH (Optio 555)
             255=> 'PICT', #PH (Optio 555)
@@ -822,5 +1120,6 @@
         {
             Name => 'FocusMode',
-            Condition => '$self->{Make} =~ /^PENTAX/',
+            # (can't test for "PENTAX" because MOV videos don't have Make)
+            Condition => '$$self{Make} !~ /^Asahi/',
             Notes => 'Pentax models',
             Writable => 'int16u',
@@ -833,12 +1132,20 @@
                 4 => 'Super Macro', #JD
                 5 => 'Pan Focus',
-                16 => 'AF-S', #17
-                17 => 'AF-C', #17
-                18 => 'AF-A', #PH (educated guess)
-                32 => 'Contrast-detect', #PH (K-5)
-                33 => 'Tracking Contrast-detect', #PH (K-5)
+                # 8 - seen for Ricoh GR III
+                # 9 - seen for Ricoh GR III
+                16 => 'AF-S (Focus-priority)', #17
+                17 => 'AF-C (Focus-priority)', #17
+                18 => 'AF-A (Focus-priority)', #PH (educated guess)
+                32 => 'Contrast-detect (Focus-priority)', #PH (K-5)
+                33 => 'Tracking Contrast-detect (Focus-priority)', #PH (K-5)
+                # bit 8 indicates release priority
+                272 => 'AF-S (Release-priority)', #PH (K-5,K-3)
+                273 => 'AF-C (Release-priority)', #PH (K-5,K-3)
+                274 => 'AF-A (Release-priority)', #PH (K-3)
+                288 => 'Contrast-detect (Release-priority)', #PH (K-01)
+                # 32777 (0x8009) - seen for Ricoh GR III
+                # 32779 (0x800b) - seen for Ricoh GR III
             },
-        },
-        {
+        },{
             Name => 'FocusMode',
             Writable => 'int16u',
